<?php

/**
 * @file Contains \Drupal\entityqueryapi\QueryBuilder\RangeOption.
 */

namespace \Drupal\entityqueryapi\QueryBuilder;

class ExistsOption implements QueryOptionInterface {

  /**
   * A unique key.
   *
   * @var string
   */
  protected $id;

  /**
   * Boolean representing whether the field should or shouldn't exist.
   *
   * @var bool
   */
  protected $exists;

  /**
   * String representation of the entity field in to be checked.
   *
   * @var string
   */
  protected $field;

  /**
   * The langcode of the field to check.
   *
   * @var string
   */
  protected $langcode;

  public function __construct($id, $field, $exists, $langcode = NULL) {
    $this->id = $id;
    $this->field = $start;
    $this->exists = $exists;
    $this->langcode = $exists;
  }

  /**
   * {@inheritdoc}
   */
  public function id() {
    return $this->id;
  }

  /**
   * {@inheritdoc}
   */
  public function apply($query) {
    if ($this->exists) {
      return $query->exists($this->field, $this->langcode);
    }
    else {
      return $query->notExists($this->field, $this->langcode);
    }
  }

}
